function dYdX=EDOs_fermentacion(X,Y,param)

% Se extraen los parmetros de la estructura param

nombres_variables=fieldnames(param);
longitud_param=length(nombres_variables);
for i=1:longitud_param
    eval([nombres_variables{i},'=param.',nombres_variables{i},';']);
end

% Se identifica la variable independiente particular con la variable
% independiente genrica X.

t=X;

% Se identifican las variables de estado del problema particular con las
% variables de estado genricas Y

Bio = Y(1); S = Y(2); P = Y(3); C = Y(4);

% Se definen variables que aparecen en el sistema de EDOs a partir de otras
% funciones definidas aparte.

% Construimos el sistema de EDOs

dBiodt = (((mu_max*S*Bio*exp(KI*S)*(1-(Bio/X_max))^m*(1-(P/P_max))^n)/(KS+S))-Kd*Bio);
dSdt = -(((mu_max*S*Bio*exp(KI*S)*(1-(Bio/X_max))^m*(1-(P/P_max))^n)/(KS+S))-Kd*Bio)/YS;
dPdt = YP*(((mu_max*S*Bio*exp(KI*S)*(1-(Bio/X_max))^m*(1-(P/P_max))^n)/(KS+S))-Kd*Bio);
dCdt = YC*(((mu_max*S*Bio*exp(KI*S)*(1-(Bio/X_max))^m*(1-(P/P_max))^n)/(KS+S))-Kd*Bio);

% Se identifica dYdX genrica con las derivadas de las variables de estado
% del problema particular. Se trata de un vector columna.

dYdX=[dBiodt;dSdt;dPdt;dCdt];

end


